//SE RECOMIENDA USAR ESTA PLANTILLA CON LA VERSION MPLAB IDE V.8.63 Y COMPILADOR C18 V3.40
//ESTE PROGRAMA USA EL COMPILADOR C18. EL ARCHIVO (.HEX) RESULTANTE DE LA COMPILACION 
//DEBE CARGARSE EN LA TARJETA BOLT DESDE LA PC CON EL SOFTWARE BOOTLOADER "bolt 1.0.1"
//ES INDISPENSABLE INTEGRAR EN EL PROYECTO DE MPLAB EL ARCHIVO "rm18f2550.lkr" QUE ES UN 
//SCRIPT PARA EL LINKER DEL C18.TAMBIN SE RECOMIENDA INCLUIR EN EL PROYECTO
//LA LIBRERA UNIVERSAL "18F2550BOLT". LAS LIBRERIAS ADICIONALES Y ARCHIVOS COMPLETOS QUE 
//USTED PUEDE NECESITAR PARA SU PROYECTO LOS ENCONTRARA EN EL ARCHIVO 
//"C18-PLANTILLAS-LIBRERIAS-BOLT.ZIP"
//MUESTRA LA TEMPERATURA LEIDA DEL SENSOR DS18B20 EN EL MODULO
//DE EXPANSION DE 7 SEGMENTOS: 1 ENTERO Y 2 DECIMALES.


#include <p18cxxx.h>
#include <delays.h>
#include <stdio.h>		//librera sprintf()
#include <stdlib.h>		//libreras atoi(),atof()
#include "18F2550BOLT.h"
#include "ONEWIRE-BOLT.h"    //librera funcin para leer sensor DS18B20

extern void _startup( void ); // See c018i.c in your C18 compiler dir 
#pragma code _RESET_INTERRUPT_VECTOR = 0x000800 
void _reset( void ) 
{ 
    _asm goto _startup _endasm 
} 

#pragma code
 
char wip[]={0X7E,0X0C,0XB6,0X9E,0XCC,0XDA,0XFA,0X0E,0XFE,0XCE};		
char yep[5]; 					//ARREGLO ALMACENA AQUI EL NUMERO				
int rib;	
long int k;
void seven(char *i);
float GRADOS;					//VARIABLE PARA TEMPERATURA
int entero,decimal;				//PARA CONVERSION DE FLOTANTE A VARIABLES ENTERAS

void main(void)
{
init_bolt();
while(1){
	RA1=1;
	RA1=0;
	GRADOS=ds1820_read();			//LEE TEMPERATURA
	entero=GRADOS;					//PARTE ENTERA
	decimal=(GRADOS-entero)*10;			//PARTE DECIMAL
	sprintf(yep,"%2d.%d",entero,decimal);		//CONVIERTE A STRING 
	TRISA=0;				//PUERTO A,SON SALIDAS
		for(k=0;k<800;k++)		//LOOP DE REPETICION DETERMINA EL TIEMPO QUE SE MUESTRA LA TEMPERATURA
		{
		RA1=1;				//PULSO MASTER RESET A CONTADOR
		RA1=0;			
			for(rib=0;rib<4;rib++)	
			{
			if(rib==2)rib=3;	//BRINCATE EL CODIGO ASCII DEL PUNTO
			seven(yep);
			}	
		}
	}			
}

//FUNCION ESCRIBE EL NUMERO INDICADO
void seven(char *i)
{int j;
RA2=1;						//PULSO SELECCIONA SIGUIENTE DISPLAY				
RA2=0;
j=*(i+rib)-48;						//CONVIERTE ASCII A BINARIO
PORTB=wip[j];					//ESCRIBE PATRON DE SEGMENTOS EN DISPLAY
if (rib==1)RB0=1;				//SI ES EL DISPLAY 2, PONE EL PUNTO
else RB0=0;	
delay_ms(5);
}	




